/*
 * The MIT License
 *
 * Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
 *
 * Copyright (C) 2021 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
 *
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
package dk.sundhedsdatastyrelsen.cbs.dao.impl.jdbc;

import dk.sundhedsdatastyrelsen.cbs.dao.PersonRecord;
import org.springframework.lang.NonNull;
import org.springframework.lang.Nullable;

import java.time.LocalDateTime;

public class PersonRecordImpl implements PersonRecord {

    @NonNull
    public static final String PERSON_IDENTIFIER_COLUMN_LABEL = "PERSON_IDENTIFIER";
    @NonNull
    public static final String FIRST_NAME_COLUMN_LABEL = "FIRST_NAME";
    @NonNull
    public static final String MIDDLE_NAME_COLUMN_LABEL = "MIDDLE_NAME";
    @NonNull
    public static final String SUR_NAME_COLUMN_LABEL = "SUR_NAME";
    @NonNull
    public static final String LAST_UPDATED_COLUMN_LABEL = "LAST_UPDATED";

    private String personIdentifier;
    private String firstName;
    private String middleName;
    private String surName;
    private LocalDateTime lastUpdated;

    @Override
    @NonNull
    public String personIdentifier() {
        return personIdentifier;
    }

    @NonNull
    public PersonRecordImpl personIdentifier(@NonNull final String personIdentifier) {
        this.personIdentifier = personIdentifier;
        return this;
    }

    @Override
    @NonNull
    public String firstName() {
        return firstName;
    }

    @NonNull
    public PersonRecordImpl firstName(@NonNull final String firstName) {
        this.firstName = firstName;
        return this;
    }

    @Override
    @Nullable
    public String middleName() {
        return middleName;
    }

    @NonNull
    public PersonRecordImpl middleName(@Nullable final String middleName) {
        this.middleName = middleName;
        return this;
    }

    @Override
    @NonNull
    public String surName() {
        return surName;
    }

    @NonNull
    public PersonRecordImpl surName(@NonNull final String surName) {
        this.surName = surName;
        return this;
    }

    @Override
    @NonNull
    public LocalDateTime lastUpdated() {
        return lastUpdated;
    }

    @NonNull
    public PersonRecordImpl lastUpdated(@NonNull final LocalDateTime lastUpdated) {
        this.lastUpdated = lastUpdated;
        return this;
    }
}
